#include <stdio.h>
#include <math.h>
#define MAXSTEPS 500
#define CU_SOLUBILITY 0.040
#define CU_MAX_SOLUBILITY 0.50
double max(double x, double y);
double min(double x, double y);
double *Calcshift (char *ID, double Fluence, double Flux, double Tirrad, double Cu, double Ni,
                   double *f, double *t, double *t_ind, double *t_enh, double *t_sc,
                   double *t_md, double *gz, double *eta);	/*vg^Cv錾*/
int main()
{
	FILE *shift;
/*	shift = fopen("result.txt","w"); 
	fprintf(shift,"Fluence,Original,2013\n");*/
	double predictionshift[3], f[MAXSTEPS], t[MAXSTEPS], t_ind[MAXSTEPS],
			t_enh[MAXSTEPS], t_sc[MAXSTEPS],t_md[MAXSTEPS], gz[18], eta[3];
	char ID[MAXSTEPS];
	double Fluence = 1.0e20;
	double Flux = 1.0e11;
	double Tirrad = 283.0;
	double Cu = 0.04;
	double Ni = 0.5;
/* JEAC4201-2007-original*/
	gz[1] = 7.8389e-6;
	gz[2] = 2.6450e-4;
	gz[3] = 3.4068e-1;
	gz[4] = 7.1620e-1;
	gz[5] = 7.6028e0 ;
	gz[6] = 7.6159e-1;
	gz[7] = 3.3033e0 ;
	gz[8] = 2.7840e2 ;
	gz[9] = 2.9500e-25;
	gz[10]= 2.4093e-2;
	gz[11]= 6.6826e-1;
	gz[12]= 6.0732e-5;
	gz[13]= 7.3670e-1;
	gz[14]= 2.4264e0 ;
	gz[15]= 7.3319e-1;
	gz[16]= 2.3457e2 ;
	gz[17]= 1.7241e0 ;
	eta[1]= 7e-6;
	eta[2]= 5.2e-1;
	printf("start\n");
	predictionshift[1] = *Calcshift(ID,Fluence, Flux, Tirrad, Cu, Ni, f, t, t_ind, t_enh, t_sc,
                   t_md, gz, eta);
	printf("predictionshift=%f\n",predictionshift[1]);
/* JEAC4201-2007-tsuiho2013 */
	gz[1] = 1.6983018e-5;
	gz[2] = 3.5228183e-4;
	gz[3] = 8.3530827e-1;
	gz[4] = 7.1620000e-1;
	gz[5] = 1.1937318e1;
	gz[6] = 4.9388038e-1;
	gz[7] = 1.7879868e1;
	gz[8] = 5.7851852e2;
	gz[9] = 6.0761276e-25;
	gz[10]= 0;
	gz[11]= 6.6826000e-1;
	gz[12]= 5.0523112e-6;
	gz[13]= 3.5092239e-1;
	gz[14]= 4.3288847e0;
	gz[15]= 7.3319000e-1;
	gz[16]= 3.0150182e2;
	gz[17]= 2.8235609e0;
	eta[1]= 3.6670381e-7;
	eta[2]= 6.1621430e-1;
	predictionshift[2] = *Calcshift(ID,Fluence, Flux, Tirrad, Cu, Ni, f, t, t_ind, t_enh, t_sc,
                   t_md, gz, eta);
	printf("predictionshift=%f\n",predictionshift[2]);
/*	fprintf(shift,"%f,%f,%f\n",Fluence,predictionshift[1],predictionshift[2]);
	printf("end\n");
	fclose(shift); */
	return;
}


/*============================================================================================
  Charpy Transition Temperature Shift Calculator
		   for Reactor Pressure Vessel Materials
  Developed by N. Soneda, A. Nemoto, K. Dohi, S. Ishino (CRIEPI)
  Copyright 2007 (C) Central Research Institute of Electric Power Industy. All right reserved.
============================================================================================*/

double max(double x, double y)
{
	if (x > y) return x;
	else       return y;
}

double min(double x, double y)
{
	if (x < y) return x;
	else       return y;
}

double *Calcshift (char *ID, double Fluence, double Flux, double Tirrad, double Cu, double Ni,
                   double *f, double *t, double *t_ind, double *t_enh, double *t_sc,
                   double *t_md, double *gz, double *eta)	/*֐|C^Ȃ킿֐̔z*/
{
   double Cu_avail[MAXSTEPS], Cu_mat[MAXSTEPS];
   double C_ind[MAXSTEPS], delta_C_ind[MAXSTEPS], C_enh[MAXSTEPS], delta_C_enh[MAXSTEPS];
   double C_sc[MAXSTEPS], C_md[MAXSTEPS];
   double vaf[MAXSTEPS], vpc[MAXSTEPS];
   double Vf[MAXSTEPS], Vf_ind[MAXSTEPS], Vf_enh[MAXSTEPS], vfc[MAXSTEPS];
   double ft[MAXSTEPS];
   double D_cu, Cu_sol, Cu_max;
   double p, q, s;
   double delta_ft, delta_tn, delta_t;
   double *prediction;
   static double pred;
   int i;
   int flag = 0;
 	for (i = 1; i < 18; i++) {
		printf("gz[%d]=%f\n",i,gz[i]);
	}
   /* initialize */
   delta_t = min (5.0e-11, 5.0 / Flux);
   delta_ft = delta_t * Flux;
   delta_tn = delta_t / 5.0e-11;
   Cu_sol = CU_SOLUBILITY;
   Cu_max = CU_MAX_SOLUBILITY;
   D_cu = 0.75 + eta[1] * pow (Flux, eta[2]);
   Cu_mat[0]        = min (Cu_max, Cu);
   Cu_avail[0]      = max (Cu_mat[0] - Cu_sol, 0);
   delta_C_ind[0]   = 0.0;
   C_ind[0]         = 0.0;
   delta_C_enh[0]   = 0.0;
   C_enh[0]         = 0.0;
   C_md[0]          = 0.0;
   ft[0]            = 0.0;
   p                = gz[4] * pow ((1.869 - 0.00457 * Tirrad) / (1.869 - 0.00457 * 288), 2.0)
                            * pow ((gz[5] + gz[6] * Ni) / (gz[5] + gz[6] * 0.6), 2.0);
   q                = D_cu * D_cu * pow ((1.0 + gz[7] * Ni) / (1.0 + gz[7] * 0.6), 2) * gz[8];
   s                = pow ((1.0 + gz[13] * pow (Ni, gz[14]))
                           / (1.0 + gz[13] * pow (0.6, gz[14])) * gz[15], 2.0);

	/* Integrate */
	for (i = 1; i < MAXSTEPS; i++) {

	/**************************************
	   MICROSTRUCTURE EVOLUTION
	 ***************************************/

/* Calculate fluence */
   ft[i] = ft[i-1] + delta_ft;
   f[i]  = ft[i] * 1.0e17;

   /* Calculate increment of irradiation-induced solute atom clusters */
   delta_C_ind[i] = min (((Cu_mat[i-1] + 0.02) * D_cu + 0.0001)
                         * (delta_ft * p + C_md[i-1] * delta_tn)
                         * gz[3], delta_ft * p + C_md[i-1] * delta_tn);
   C_ind[i] = C_ind[i-1] + delta_C_ind[i];

   /* Calculate increment of irradiation-enhanced solute atom clusters */
   delta_C_enh[i] = Cu_avail[i-1] * Cu_avail[i-1] * q * delta_tn;
   C_enh[i] = C_enh[i-1] + delta_C_enh[i];

   /* Calculate SC number density */
   C_sc[i] = C_ind[i] + C_enh[i];

   /* Calculate Cu content in solution */
   vaf[i] = gz[2] * Cu_avail[i-1] * Cu_avail[i-1] * D_cu * D_cu * delta_tn;
   Cu_mat[i] = Cu_mat[i-1] - vaf[i] * delta_C_enh[i]
                             - D_cu * Cu_avail[i-1] * gz[1] * C_sc[i] * delta_tn;
   Cu_avail[i] = max (Cu_mat[i] - Cu_sol, 0.0);

   /* Calculate Matrix Damage */
   C_md[i] = C_md[i-1] + max (delta_ft * p - delta_C_ind[i], 0.0);

   /* Calculate volume fraction */
   vpc[i]    = (min (Cu, Cu_max) - Cu_mat[i]) / C_sc[i];
   vfc[i]    = f[i] * gz[9] * (1.0 + gz[10] * D_cu) + (vpc[i] * gz[11] + gz[12]) * s;
   Vf_ind[i] = vfc[i] * C_ind[i];
   Vf_enh[i] = vfc[i] * C_enh[i];
   Vf[i]     = Vf_ind[i] + Vf_enh[i];

   /**************************************
     MECHANICAL PROPERTY CHANGE
   ***************************************/
   t_ind[i] = gz[16] * sqrt(Vf_ind[i]);
   t_enh[i] = gz[16] * sqrt(Vf_enh[i]);
   t_sc [i] = gz[16] * sqrt(Vf[i]);
   t_md [i] = gz[17] * sqrt(C_md[i]);
   t[i] = sqrt (t_sc[i] * t_sc[i] + t_md[i] * t_md[i]);
   printf("f[%d]=%f, t[%d]=%f\n", i, f[i],i,t[i]); 
}

/**************************************
  INTERPORATION OF TEMPERATURE SHIFT
***************************************/
pred = 0.0; prediction = NULL;
	if (Fluence == 0.0) {
		prediction = &pred;				/* prediction̓|C^ϐȂ̂ŃAhX */
	}	else if (Fluence < 0.0) {
			prediction = NULL;
	}	else {
		for (i = 1; i < MAXSTEPS; i++) {
			if (Fluence < f[i]) {
				double r1, r2;
				flag = 1;
				r1 = (Fluence - f[i-1]) / (f[i] - f[i-1]);
				r2 = (f[i] - Fluence) / (f[i] - f[i-1]);
				pred = t[i] * r1 + t[i-1] * r2;
				printf("i=%d, t[i]=%f, t[i-1]=%f, r1=%f, r2=%f \n", i,t[i],t[i-1],r1,r2);
				break;
			}
		}
		if (flag == 1)
			prediction = &pred;
	}
	return prediction;
}